(function($dvt$$18$$) {
  function $DvtTimeAxisParser$$() {
  }
  function $DvtTimeAxisFormatter$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $locale$$6$$) {
    this.Init($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $locale$$6$$);
  }
  function $DvtTimeAxisDefaults$$() {
    this.Init({alta:$DvtTimeAxisDefaults$$.$VERSION_1$});
  }
  function $DvtTimeAxisCalendar$$($dvt$$18$$) {
    this.Init($dvt$$18$$);
  }
  $dvt$$18$$.$TimeAxis$ = function $$dvt$$18$$$$TimeAxis$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $callbackObj$$91$$) {
    this.Init($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $callbackObj$$91$$);
  };
  $dvt$$18$$.$Obj$.$createSubclass$($dvt$$18$$.$TimeAxis$, $dvt$$18$$.$BaseComponent$);
  $dvt$$18$$.$TimeAxis$.$ORIENTATION_VERTICAL$ = "vertical";
  $dvt$$18$$.$TimeAxis$.$supportsTouch$ = function $$dvt$$18$$$$TimeAxis$$$supportsTouch$$() {
    return $dvt$$18$$.$Agent$.$isTouchDevice$();
  };
  $dvt$$18$$.$TimeAxis$.$getDatePosition$ = function $$dvt$$18$$$$TimeAxis$$$getDatePosition$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $number$$3_time$$16$$, $width$$141$$) {
    $number$$3_time$$16$$ = ($number$$3_time$$16$$ - $dvt$$18$$) * $width$$141$$;
    $dvt$$18$$ = $DvtTimeAxisStyleUtils$$ - $dvt$$18$$;
    return 0 == $number$$3_time$$16$$ || 0 == $dvt$$18$$ ? 0 : $number$$3_time$$16$$ / $dvt$$18$$;
  };
  $dvt$$18$$.$TimeAxis$.$getPositionDate$ = function $$dvt$$18$$$$TimeAxis$$$getPositionDate$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $pos$$73$$, $width$$142$$) {
    $DvtTimeAxisStyleUtils$$ = $pos$$73$$ * ($DvtTimeAxisStyleUtils$$ - $dvt$$18$$);
    return 0 == $DvtTimeAxisStyleUtils$$ || 0 == $width$$142$$ ? $dvt$$18$$ : $DvtTimeAxisStyleUtils$$ / $width$$142$$ + $dvt$$18$$;
  };
  $dvt$$18$$.$TimeAxis$.newInstance = function $$dvt$$18$$$$TimeAxis$$newInstance$($context$$421$$, $DvtTimeAxisStyleUtils$$, $callbackObj$$92$$) {
    return new $dvt$$18$$.$TimeAxis$($context$$421$$, $DvtTimeAxisStyleUtils$$, $callbackObj$$92$$);
  };
  $dvt$$18$$.$TimeAxis$.$_VALID_SCALES$ = "seconds minutes hours days weeks months quarters years".split(" ");
  $dvt$$18$$.$TimeAxis$.prototype.Init = function $$dvt$$18$$$$TimeAxis$$$Init$($context$$422$$, $callback$$172$$, $callbackObj$$93$$) {
    $dvt$$18$$.$TimeAxis$.$superclass$.Init.call(this, $context$$422$$, $callback$$172$$, $callbackObj$$93$$);
    this.$_calendar$ = new $DvtTimeAxisCalendar$$;
    this.$_borderWidth$ = $DvtTimeAxisStyleUtils$$.$DEFAULT_BORDER_WIDTH$;
    this.$setBorderVisibility$(!1, !1, !1, !1);
    this.$_dateToIsoWithTimeZoneConverter$ = $context$$422$$.$getLocaleHelpers$().dateToIsoWithTimeZoneConverter;
    this.$_dateFormatStrings$ = {$dayNames$:[$dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_SHORT_SUNDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_SHORT_MONDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_SHORT_TUESDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_SHORT_WEDNESDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, 
    "DAY_SHORT_THURSDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_SHORT_FRIDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_SHORT_SATURDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_SUNDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_MONDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, 
    "DAY_TUESDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_WEDNESDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_THURSDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_FRIDAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "DAY_SATURDAY", null)], $monthNames$:[$dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, 
    "MONTH_SHORT_JANUARY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_SHORT_FEBRUARY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_SHORT_MARCH", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_SHORT_APRIL", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_SHORT_MAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, 
    "MONTH_SHORT_JUNE", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_SHORT_JULY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_SHORT_AUGUST", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_SHORT_SEPTEMBER", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_SHORT_OCTOBER", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, 
    "MONTH_SHORT_NOVEMBER", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_SHORT_DECEMBER", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_JANUARY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_FEBRUARY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_MARCH", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, 
    "MONTH_APRIL", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_MAY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_JUNE", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_JULY", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_AUGUST", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_SEPTEMBER", 
    null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_OCTOBER", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_NOVEMBER", null), $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "MONTH_DECEMBER", null)]};
    this.$Defaults$ = new $DvtTimeAxisDefaults$$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$SetOptions$ = function $$dvt$$18$$$$TimeAxis$$$$SetOptions$$($dvt$$18$$) {
    this.$Options$ = this.$Defaults$.$calcOptions$($dvt$$18$$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$Parse$ = function $$dvt$$18$$$$TimeAxis$$$$Parse$$($dvt$$18$$) {
    this.$_parser$ = new $DvtTimeAxisParser$$;
    return this.$_parser$.parse($dvt$$18$$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$_applyParsedProperties$ = function $$dvt$$18$$$$TimeAxis$$$$_applyParsedProperties$$($props$$13$$) {
    var $DvtTimeAxisStyleUtils$$ = $props$$13$$.orientation;
    this.$_isVertical$ = $DvtTimeAxisStyleUtils$$ && $DvtTimeAxisStyleUtils$$ == $dvt$$18$$.$TimeAxis$.$ORIENTATION_VERTICAL$ ? !0 : !1;
    this.$setIsVertical$(this.$_isVertical$);
    this.$_shortDesc$ = $props$$13$$.$shortDesc$;
    this.$_zoomOrder$ = $props$$13$$.$zoomOrder$ ? $props$$13$$.$zoomOrder$.reverse() : [$props$$13$$.scale];
    this.$_timeZoneOffsets$ = $props$$13$$.$timeZoneOffsets$;
    this.$_customTimeScales$ = $props$$13$$.$customTimeScales$;
    this.$_customFormatScales$ = $props$$13$$.$customFormatScales$;
    this.$_start$ = $props$$13$$.start;
    this.$_end$ = $props$$13$$.end;
    this.$_inlineStyle$ = $props$$13$$.$inlineStyle$;
    this.$_scale$ = $props$$13$$.scale;
    this.$_converter$ = $props$$13$$.$converter$;
    this.$applyStyleValues$();
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setContentLength$ = function $$dvt$$18$$$$TimeAxis$$$$setContentLength$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$) {
    if ("undefined" === typeof $DvtTimeAxisStyleUtils$$ || null === $DvtTimeAxisStyleUtils$$) {
      $DvtTimeAxisStyleUtils$$ = this.$_canvasLength$;
    }
    this.$_contentLength$ = $DvtTimeAxisStyleUtils$$ < $dvt$$18$$ ? $dvt$$18$$ : $DvtTimeAxisStyleUtils$$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$isRTL$ = function $$dvt$$18$$$$TimeAxis$$$$isRTL$$() {
    return $dvt$$18$$.$Agent$.$isRightToLeft$(this.$getCtx$());
  };
  $dvt$$18$$.$TimeAxis$.prototype.$isVertical$ = function $$dvt$$18$$$$TimeAxis$$$$isVertical$$() {
    return this.$_isVertical$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$render$ = function $$dvt$$18$$$$TimeAxis$$$$render$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $height$$120$$) {
    $dvt$$18$$ && !this.$Options$ && (this.$Width$ = $DvtTimeAxisStyleUtils$$, this.$Height$ = $height$$120$$, this.$_prepareCanvasViewport$(), this.$getPreferredLength$($dvt$$18$$, this.$_canvasLength$));
    this.$_handleResize$($DvtTimeAxisStyleUtils$$, $height$$120$$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$getPreferredLength$ = function $$dvt$$18$$$$TimeAxis$$$$getPreferredLength$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$) {
    this.$SetOptions$($dvt$$18$$);
    this.$_resources$ = this.$Options$._resources;
    null == this.$_resources$ && (this.$_resources$ = []);
    this.$_locale$ = this.$Options$._locale ? this.$Options$._locale : "en-US";
    var $firstDayOfWeek_props$$14$$ = this.$_resources$.firstDayOfWeek;
    null == $firstDayOfWeek_props$$14$$ && ($firstDayOfWeek_props$$14$$ = 0);
    this.$_calendar$.$setFirstDayOfWeek$($firstDayOfWeek_props$$14$$);
    this.$_dateToIsoWithTimeZoneConverter$ || (this.$_dateToIsoWithTimeZoneConverter$ = this.$getCtx$().$getLocaleHelpers$().dateToIsoWithTimeZoneConverter);
    $firstDayOfWeek_props$$14$$ = this.$Parse$(this.$Options$);
    this.$_applyParsedProperties$($firstDayOfWeek_props$$14$$);
    this.$_scale$ && this.$prepareTimeAxisZoomLevelIntervals$(this.$_start$, this.$_end$, $DvtTimeAxisStyleUtils$$);
    return this.$_contentLength$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$hasValidOptions$ = function $$dvt$$18$$$$TimeAxis$$$$hasValidOptions$$() {
    var $hasValidScale$$ = this.$_scale$ && -1 != $dvt$$18$$.$ArrayUtils$.$getIndex$($dvt$$18$$.$TimeAxis$.$_VALID_SCALES$, this.$_scale$), $DvtTimeAxisStyleUtils$$ = this.$_scale$ && this.$_customTimeScales$ && this.$_customTimeScales$[this.$_scale$], $hasValidStartAndEnd$$1$$ = this.$_start$ && this.$_end$ && this.$_end$ > this.$_start$;
    return ($hasValidScale$$ || $DvtTimeAxisStyleUtils$$) && $hasValidStartAndEnd$$1$$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$GetComponentDescription$ = function $$dvt$$18$$$$TimeAxis$$$$GetComponentDescription$$() {
    return this.$_shortDesc$ ? this.$_shortDesc$ : $dvt$$18$$.$Bundle$.$getTranslatedString$($dvt$$18$$.$Bundle$.$UTIL_PREFIX$, "TIMEAXIS");
  };
  $dvt$$18$$.$TimeAxis$.prototype.$applyStyleValues$ = function $$dvt$$18$$$$TimeAxis$$$$applyStyleValues$$() {
    this.$_axisStyle$ = new $dvt$$18$$.$CSSStyle$($DvtTimeAxisStyleUtils$$.$getAxisStyle$(this.$Options$));
    this.$_axisStyle$.$parseInlineStyle$(this.$_inlineStyle$);
    var $axisBorderWidth$$ = this.$_axisStyle$.$getBorderWidth$();
    this.$_axisStyle$.$parseInlineStyle$("border:" + 2 * $axisBorderWidth$$ + "px;");
    this.$setBorderWidth$($axisBorderWidth$$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$_prepareCanvasViewport$ = function $$dvt$$18$$$$TimeAxis$$$$_prepareCanvasViewport$$() {
    this.$_isVertical$ ? (this.$_canvasLength$ = this.$Height$, this.$_canvasSize$ = this.$Width$) : (this.$_canvasLength$ = this.$Width$, this.$_canvasSize$ = this.$Height$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$_setAxisDimensions$ = function $$dvt$$18$$$$TimeAxis$$$$_setAxisDimensions$$() {
    null !== this.$_canvasSize$ && this.$setContentSize$(this.$_canvasSize$ - this.$getSizeBorderWidth$());
    this.$_axisLength$ = this.$_contentLength$ + this.$getSizeBorderWidth$() - $DvtTimeAxisStyleUtils$$.$DEFAULT_SEPARATOR_WIDTH$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$_updateDimensions$ = function $$dvt$$18$$$$TimeAxis$$$$_updateDimensions$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$) {
    this.$Width$ = $dvt$$18$$;
    this.$Height$ = $DvtTimeAxisStyleUtils$$;
    this.$_prepareCanvasViewport$();
    this.$setContentLength$(this.$_canvasLength$);
    this.$_setAxisDimensions$();
  };
  $dvt$$18$$.$TimeAxis$.prototype.$_handleResize$ = function $$dvt$$18$$$$TimeAxis$$$$_handleResize$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$) {
    this.$_updateDimensions$($dvt$$18$$, $DvtTimeAxisStyleUtils$$);
    $DvtTimeAxisRenderer$$.$renderTimeAxis$(this);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$prepareTimeAxisZoomLevelIntervals$ = function $$dvt$$18$$$$TimeAxis$$$$prepareTimeAxisZoomLevelIntervals$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $minViewPortLength$$1$$) {
    this.$setConverter$(this.$_converter$);
    this.$setType$("short", this.$_dateFormatStrings$);
    this.$_dates$ = [];
    this.$_labels$ = [];
    this.$_zoomLevelLengths$ = [];
    this.$_isVertical$ ? this.$setDefaultConverter$(this.$_resources$.converterVert) : this.$setDefaultConverter$(this.$_resources$.converter);
    this.$_timeZoneOffsets$ && this.$setTimeZoneOffsets$(this.$_timeZoneOffsets$);
    for (var $originalScale$$ = this.$_scale$, $DvtTimeAxisCalendar$$ = 0;$DvtTimeAxisCalendar$$ < this.$_zoomOrder$.length;$DvtTimeAxisCalendar$$++) {
      var $DvtTimeAxisRenderer$$ = this.$_zoomOrder$[$DvtTimeAxisCalendar$$], $DvtTimeAxisFormatter$$ = this.$_prepareScaleDatesLabels$($DvtTimeAxisRenderer$$, $originalScale$$, $dvt$$18$$, $DvtTimeAxisStyleUtils$$);
      this.$_prepareZoomLevelLengths$($DvtTimeAxisCalendar$$, $DvtTimeAxisRenderer$$, $dvt$$18$$, $DvtTimeAxisStyleUtils$$, $DvtTimeAxisFormatter$$, $minViewPortLength$$1$$);
    }
    this.$setScale$($originalScale$$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$_prepareScaleDatesLabels$ = function $$dvt$$18$$$$TimeAxis$$$$_prepareScaleDatesLabels$$($dates_scale$$56$$, $DvtTimeAxisCalendar$$, $currentTime_lengthFactor_startTime$$18$$, $endTime$$15_labels$$31$$) {
    this.$setScale$($dates_scale$$56$$);
    var $DvtTimeAxisRenderer$$ = Infinity, $maxSize$$5$$ = 0, $DvtTimeAxisFormatter$$;
    if (this.$_customTimeScales$ && this.$_customTimeScales$[$dates_scale$$56$$]) {
      $DvtTimeAxisFormatter$$ = this.$_customTimeScales$[$dates_scale$$56$$], $dates_scale$$56$$ = $DvtTimeAxisFormatter$$.times, $DvtTimeAxisFormatter$$ = $DvtTimeAxisFormatter$$.labels;
    } else {
      if (this.$_customFormatScales$ && this.$_customFormatScales$[$dates_scale$$56$$]) {
        $DvtTimeAxisFormatter$$ = this.$_customFormatScales$[$dates_scale$$56$$], $dates_scale$$56$$ = $DvtTimeAxisFormatter$$.times, $DvtTimeAxisFormatter$$ = $DvtTimeAxisFormatter$$.labels;
      } else {
        for ($dates_scale$$56$$ = [], $DvtTimeAxisFormatter$$ = [], $currentTime_lengthFactor_startTime$$18$$ = this.$adjustDate$($currentTime_lengthFactor_startTime$$18$$).getTime(), $dates_scale$$56$$.push($currentTime_lengthFactor_startTime$$18$$);$currentTime_lengthFactor_startTime$$18$$ < $endTime$$15_labels$$31$$;) {
          $DvtTimeAxisFormatter$$.push(this.$formatDate$(new Date($currentTime_lengthFactor_startTime$$18$$))), $currentTime_lengthFactor_startTime$$18$$ = this.$getNextDate$($currentTime_lengthFactor_startTime$$18$$).getTime(), $dates_scale$$56$$.push($currentTime_lengthFactor_startTime$$18$$);
        }
      }
    }
    $endTime$$15_labels$$31$$ = [];
    for (var $j$$95$$ = 0;$j$$95$$ < $DvtTimeAxisFormatter$$.length;$j$$95$$++) {
      $currentTime_lengthFactor_startTime$$18$$ = $dates_scale$$56$$[$j$$95$$];
      var $label$$107$$ = new $dvt$$18$$.$OutputText$(this.$getCtx$(), $DvtTimeAxisFormatter$$[$j$$95$$], 0, 0, "s_label" + $currentTime_lengthFactor_startTime$$18$$);
      $label$$107$$.$setCSSStyle$($DvtTimeAxisStyleUtils$$.$getAxisLabelStyle$(this.$Options$));
      $label$$107$$.time = $currentTime_lengthFactor_startTime$$18$$;
      var $nextTime$$ = $dates_scale$$56$$[$j$$95$$ + 1];
      this.$addChild$($label$$107$$);
      var $dim$$76_sizeDim$$ = $label$$107$$.$getDimensions$();
      this.removeChild($label$$107$$);
      if (this.$_isVertical$) {
        var $lengthDim$$ = $dim$$76_sizeDim$$.$h$, $dim$$76_sizeDim$$ = $dim$$76_sizeDim$$.$w$, $defaultLength$$ = $DvtTimeAxisStyleUtils$$.$DEFAULT_INTERVAL_HEIGHT$
      } else {
        $lengthDim$$ = $dim$$76_sizeDim$$.$w$, $dim$$76_sizeDim$$ = $dim$$76_sizeDim$$.$h$, $defaultLength$$ = $DvtTimeAxisStyleUtils$$.$DEFAULT_INTERVAL_WIDTH$;
      }
      $currentTime_lengthFactor_startTime$$18$$ = ($nextTime$$ - $currentTime_lengthFactor_startTime$$18$$) / Math.max($defaultLength$$, $lengthDim$$ + 2 * $DvtTimeAxisStyleUtils$$.$DEFAULT_INTERVAL_PADDING$);
      $currentTime_lengthFactor_startTime$$18$$ < $DvtTimeAxisRenderer$$ && ($DvtTimeAxisRenderer$$ = $currentTime_lengthFactor_startTime$$18$$);
      $dim$$76_sizeDim$$ > $maxSize$$5$$ && ($maxSize$$5$$ = $dim$$76_sizeDim$$);
      $endTime$$15_labels$$31$$.push($label$$107$$);
    }
    this.$setContentSize$($maxSize$$5$$ + 2 * $DvtTimeAxisStyleUtils$$.$DEFAULT_INTERVAL_PADDING$);
    this.$_dates$.push($dates_scale$$56$$);
    this.$_labels$.push($endTime$$15_labels$$31$$);
    this.$setScale$($DvtTimeAxisCalendar$$);
    return $DvtTimeAxisRenderer$$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$_prepareZoomLevelLengths$ = function $$dvt$$18$$$$TimeAxis$$$$_prepareZoomLevelLengths$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $startTime$$19_zoomLevelLength$$, $endTime$$16$$, $DvtTimeAxisCalendar$$, $DvtTimeAxisRenderer$$) {
    $startTime$$19_zoomLevelLength$$ = null !== this.$_canvasSize$ ? $DvtTimeAxisRenderer$$ : ($endTime$$16$$ - $startTime$$19_zoomLevelLength$$) / $DvtTimeAxisCalendar$$;
    this.$_zoomLevelLengths$.push($startTime$$19_zoomLevelLength$$);
    $DvtTimeAxisStyleUtils$$ == this.$_scale$ && (this.$_zoomLevelOrder$ = $dvt$$18$$, this.$setContentLength$($startTime$$19_zoomLevelLength$$, $DvtTimeAxisRenderer$$));
    0 == $dvt$$18$$ && (this.$_maxContentLength$ = this.$_labels$[this.$_labels$.length - 1].length * $DvtTimeAxisRenderer$$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setScale$ = function $$dvt$$18$$$$TimeAxis$$$$setScale$$($dvt$$18$$) {
    this.$_scale$ = $dvt$$18$$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setTimeZoneOffsets$ = function $$dvt$$18$$$$TimeAxis$$$$setTimeZoneOffsets$$($dvt$$18$$) {
    this.$_timeZoneOffsets$ = $dvt$$18$$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$increaseScale$ = function $$dvt$$18$$$$TimeAxis$$$$increaseScale$$() {
    for (var $dvt$$18$$ = 0;$dvt$$18$$ < this.$_zoomOrder$.length - 1;$dvt$$18$$++) {
      if (this.$_zoomOrder$[$dvt$$18$$] == this.$_scale$) {
        this.$_scale$ = this.$_zoomOrder$[$dvt$$18$$ + 1];
        break;
      }
    }
  };
  $dvt$$18$$.$TimeAxis$.prototype.$decreaseScale$ = function $$dvt$$18$$$$TimeAxis$$$$decreaseScale$$() {
    for (var $dvt$$18$$ = 1;$dvt$$18$$ < this.$_zoomOrder$.length;$dvt$$18$$++) {
      if (this.$_zoomOrder$[$dvt$$18$$] == this.$_scale$) {
        this.$_scale$ = this.$_zoomOrder$[$dvt$$18$$ - 1];
        break;
      }
    }
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setConverter$ = function $$dvt$$18$$$$TimeAxis$$$$setConverter$$($dvt$$18$$) {
    this.$_converter$ = $dvt$$18$$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setDefaultConverter$ = function $$dvt$$18$$$$TimeAxis$$$$setDefaultConverter$$($dvt$$18$$) {
    this.$_defaultConverter$ = $dvt$$18$$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setContentSize$ = function $$dvt$$18$$$$TimeAxis$$$$setContentSize$$($dvt$$18$$) {
    $dvt$$18$$ > this.$_contentSize$ && (this.$_contentSize$ = $dvt$$18$$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$getTimeAxisWidth$ = function $$dvt$$18$$$$TimeAxis$$$$getTimeAxisWidth$$() {
    null == this.$_timeAxisWidth$ && (this.$_timeAxisWidth$ = 30);
    return this.$_timeAxisWidth$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setBorderWidth$ = function $$dvt$$18$$$$TimeAxis$$$$setBorderWidth$$($dvt$$18$$) {
    this.$_borderWidth$ = $dvt$$18$$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setBorderVisibility$ = function $$dvt$$18$$$$TimeAxis$$$$setBorderVisibility$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $bottom$$10$$, $left$$14$$) {
    this.$_borderTopWidth$ = ($dvt$$18$$ | 0) * this.$_borderWidth$;
    this.$_borderRightWidth$ = ($DvtTimeAxisStyleUtils$$ | 0) * this.$_borderWidth$;
    this.$_borderBottomWidth$ = ($bottom$$10$$ | 0) * this.$_borderWidth$;
    this.$_borderLeftWidth$ = ($left$$14$$ | 0) * this.$_borderWidth$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$calcStrokeDashArray$ = function $$dvt$$18$$$$TimeAxis$$$$calcStrokeDashArray$$() {
    for (var $dvt$$18$$ = this.$_isVertical$ ? {top:this.$getSize$(), right:this.$_axisLength$, bottom:this.$getSize$(), left:this.$_axisLength$} : {top:this.$_axisLength$, right:this.$getSize$(), bottom:this.$_axisLength$, left:this.$getSize$()}, $DvtTimeAxisStyleUtils$$ = [], $currentDashLength$$ = 0, $currentDashState$$ = 1, $DvtTimeAxisCalendar$$ = ["top", "right", "bottom", "left"], $DvtTimeAxisRenderer$$ = 0;$DvtTimeAxisRenderer$$ < $DvtTimeAxisCalendar$$.length;$DvtTimeAxisRenderer$$++) {
      0 < this.$getBorderWidth$($DvtTimeAxisCalendar$$[$DvtTimeAxisRenderer$$]) == $currentDashState$$ ? $currentDashLength$$ += $dvt$$18$$[$DvtTimeAxisCalendar$$[$DvtTimeAxisRenderer$$]] : ($DvtTimeAxisStyleUtils$$.push($currentDashLength$$), $currentDashLength$$ = $dvt$$18$$[$DvtTimeAxisCalendar$$[$DvtTimeAxisRenderer$$]], $currentDashState$$ = Math.abs($currentDashState$$ - 1));
    }
    $DvtTimeAxisStyleUtils$$.push($currentDashLength$$);
    return $DvtTimeAxisStyleUtils$$.toString();
  };
  $dvt$$18$$.$TimeAxis$.prototype.$getSizeBorderWidth$ = function $$dvt$$18$$$$TimeAxis$$$$getSizeBorderWidth$$() {
    return this.$_borderTopWidth$ + this.$_borderBottomWidth$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$getBorderWidth$ = function $$dvt$$18$$$$TimeAxis$$$$getBorderWidth$$($dvt$$18$$) {
    switch($dvt$$18$$) {
      case "top":
        return this.$_borderTopWidth$;
      case "right":
        return this.$_borderRightWidth$;
      case "bottom":
        return this.$_borderBottomWidth$;
      case "left":
        return this.$_borderLeftWidth$;
      default:
        return this.$_borderWidth$;
    }
  };
  $dvt$$18$$.$TimeAxis$.prototype.$getSize$ = function $$dvt$$18$$$$TimeAxis$$$$getSize$$() {
    return this.$_contentSize$ + this.$getSizeBorderWidth$();
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setType$ = function $$dvt$$18$$$$TimeAxis$$$$setType$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$) {
    this.$_formatter$ = new $DvtTimeAxisFormatter$$("short" == $dvt$$18$$ ? $DvtTimeAxisFormatter$$.SHORT : $DvtTimeAxisFormatter$$.$LONG$, $DvtTimeAxisStyleUtils$$, this.$_locale$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$adjustDate$ = function $$dvt$$18$$$$TimeAxis$$$$adjustDate$$($dvt$$18$$) {
    return this.$_calendar$.$adjustDate$(new Date($dvt$$18$$), this.$_scale$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$getNextDate$ = function $$dvt$$18$$$$TimeAxis$$$$getNextDate$$($dvt$$18$$) {
    return this.$_calendar$.$getNextDate$($dvt$$18$$, this.$_scale$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$formatDate$ = function $$dvt$$18$$$$TimeAxis$$$$formatDate$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $converterFactory_converterType_options$$343$$) {
    var $scale$$59$$ = this.$_scale$;
    if ("axis" == ($converterFactory_converterType_options$$343$$ || "axis")) {
      ($DvtTimeAxisStyleUtils$$ = $DvtTimeAxisStyleUtils$$ || this.$_converter$) ? $DvtTimeAxisStyleUtils$$[$scale$$59$$] ? $DvtTimeAxisStyleUtils$$ = $DvtTimeAxisStyleUtils$$[$scale$$59$$] : $DvtTimeAxisStyleUtils$$["default"] && ($DvtTimeAxisStyleUtils$$ = $DvtTimeAxisStyleUtils$$["default"]) : this.$_defaultConverter$ && this.$_defaultConverter$[$scale$$59$$] && ($DvtTimeAxisStyleUtils$$ = this.$_defaultConverter$[$scale$$59$$]);
    } else {
      if (!$DvtTimeAxisStyleUtils$$) {
        if ($DvtTimeAxisStyleUtils$$ = "hours" == $scale$$59$$ || "minutes" == $scale$$59$$ || "seconds" == $scale$$59$$ ? {formatType:"datetime", dateFormat:"medium", timeFormat:"medium"} : {formatType:"date", dateFormat:"medium"}, $converterFactory_converterType_options$$343$$ = this.$_resources$.converterFactory) {
          $DvtTimeAxisStyleUtils$$ = $converterFactory_converterType_options$$343$$.createConverter($DvtTimeAxisStyleUtils$$);
        } else {
          $DvtTimeAxisStyleUtils$$ = "toLocaleDateString";
          $converterFactory_converterType_options$$343$$ = {year:"numeric", month:"short", day:"numeric"};
          if ("hours" == $scale$$59$$ || "minutes" == $scale$$59$$ || "seconds" == $scale$$59$$) {
            $DvtTimeAxisStyleUtils$$ = "toLocaleString", $converterFactory_converterType_options$$343$$ = {year:"numeric", month:"short", day:"numeric", hour:"numeric", minute:"numeric", second:"numeric"};
          }
          try {
            return $dvt$$18$$[$DvtTimeAxisStyleUtils$$](this.$_locale$, $converterFactory_converterType_options$$343$$);
          } catch ($DvtTimeAxisCalendar$$) {
          }
          return $dvt$$18$$[$DvtTimeAxisStyleUtils$$]();
        }
      }
    }
    if ($DvtTimeAxisStyleUtils$$) {
      if ($DvtTimeAxisStyleUtils$$.format) {
        return $DvtTimeAxisStyleUtils$$.format(this.$_dateToIsoWithTimeZoneConverter$ ? this.$_dateToIsoWithTimeZoneConverter$($dvt$$18$$) : $dvt$$18$$);
      }
      if ($DvtTimeAxisStyleUtils$$.getAsString) {
        return $DvtTimeAxisStyleUtils$$.getAsString($dvt$$18$$);
      }
    }
    return this.$_formatter$.format($dvt$$18$$, $scale$$59$$, this.$_timeZoneOffsets$);
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setIsVertical$ = function $$dvt$$18$$$$TimeAxis$$$$setIsVertical$$($dvt$$18$$) {
    this.$_contentSize$ = $dvt$$18$$ ? $DvtTimeAxisStyleUtils$$.$DEFAULT_INTERVAL_WIDTH$ : $DvtTimeAxisStyleUtils$$.$DEFAULT_INTERVAL_HEIGHT$;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setCanvasSize$ = function $$dvt$$18$$$$TimeAxis$$$$setCanvasSize$$() {
    this.$_canvasSize$ = null;
  };
  $dvt$$18$$.$TimeAxis$.prototype.$setZoomLevelOrder$ = function $$dvt$$18$$$$TimeAxis$$$$setZoomLevelOrder$$($dvt$$18$$) {
    this.$_zoomLevelOrder$ = $dvt$$18$$;
  };
  $dvt$$18$$.$Obj$.$createSubclass$($DvtTimeAxisCalendar$$, $dvt$$18$$.$Obj$);
  $DvtTimeAxisCalendar$$.prototype.Init = function $$DvtTimeAxisCalendar$$$$Init$() {
    this.$_dayInMillis$ = 864E5;
    this.$_firstDayOfWeek$ = 0;
  };
  $DvtTimeAxisCalendar$$.prototype.$setFirstDayOfWeek$ = function $$DvtTimeAxisCalendar$$$$$setFirstDayOfWeek$$($dvt$$18$$) {
    this.$_firstDayOfWeek$ = $dvt$$18$$;
  };
  $DvtTimeAxisCalendar$$.prototype.$adjustDate$ = function $$DvtTimeAxisCalendar$$$$$adjustDate$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$) {
    var $_adjustedDate$$ = new Date($dvt$$18$$.getTime());
    if ("weeks" == $DvtTimeAxisStyleUtils$$) {
      $_adjustedDate$$.setHours(0, 0, 0);
      var $roll_amt$$ = ($dvt$$18$$.getDay() - this.$_firstDayOfWeek$ + 7) % 7;
      0 < $roll_amt$$ && $_adjustedDate$$.setTime($_adjustedDate$$.getTime() - $roll_amt$$ * this.$_dayInMillis$);
    } else {
      "months" == $DvtTimeAxisStyleUtils$$ ? $_adjustedDate$$.setDate(1) : "days" == $DvtTimeAxisStyleUtils$$ ? $_adjustedDate$$.setHours(0, 0, 0) : "hours" == $DvtTimeAxisStyleUtils$$ ? $_adjustedDate$$.setMinutes(0, 0, 0) : "minutes" == $DvtTimeAxisStyleUtils$$ ? $_adjustedDate$$.setSeconds(0, 0) : "seconds" == $DvtTimeAxisStyleUtils$$ ? $_adjustedDate$$.setMilliseconds(0) : "quarters" == $DvtTimeAxisStyleUtils$$ ? ($_adjustedDate$$.setDate(1), $roll_amt$$ = 2 - ($dvt$$18$$.getMonth() + 11) % 3, 
      0 < $roll_amt$$ && $_adjustedDate$$.setMonth($_adjustedDate$$.getMonth() + $roll_amt$$)) : "halfyears" == $DvtTimeAxisStyleUtils$$ ? ($_adjustedDate$$.setDate(1), $roll_amt$$ = 5 - ($dvt$$18$$.getMonth() + 11) % 6, 0 < $roll_amt$$ && $_adjustedDate$$.setMonth($_adjustedDate$$.getMonth() + $roll_amt$$)) : "years" == $DvtTimeAxisStyleUtils$$ ? ($_adjustedDate$$.setMonth(0), $_adjustedDate$$.setDate(1)) : "twoyears" == $DvtTimeAxisStyleUtils$$ && ($_adjustedDate$$.setMonth(0), $_adjustedDate$$.setDate(1))
      ;
    }
    return $_adjustedDate$$;
  };
  $DvtTimeAxisCalendar$$.prototype.$getNextDate$ = function $$DvtTimeAxisCalendar$$$$$getNextDate$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$) {
    if ("seconds" == $DvtTimeAxisStyleUtils$$) {
      return new Date($dvt$$18$$ + 1E3);
    }
    if ("minutes" == $DvtTimeAxisStyleUtils$$) {
      return new Date($dvt$$18$$ + 6E4);
    }
    if ("hours" == $DvtTimeAxisStyleUtils$$) {
      return new Date($dvt$$18$$ + 36E5);
    }
    var $_nextDate$$ = new Date($dvt$$18$$);
    "days" == $DvtTimeAxisStyleUtils$$ ? $_nextDate$$.setDate($_nextDate$$.getDate() + 1) : "weeks" == $DvtTimeAxisStyleUtils$$ ? $_nextDate$$.setDate($_nextDate$$.getDate() + 7) : "months" == $DvtTimeAxisStyleUtils$$ ? $_nextDate$$.setMonth($_nextDate$$.getMonth() + 1) : "quarters" == $DvtTimeAxisStyleUtils$$ ? $_nextDate$$.setMonth($_nextDate$$.getMonth() + 3) : "halfyears" == $DvtTimeAxisStyleUtils$$ ? $_nextDate$$.setMonth($_nextDate$$.getMonth() + 6) : "years" == $DvtTimeAxisStyleUtils$$ ? $_nextDate$$.setFullYear($_nextDate$$.getFullYear() + 
    1) : "twoyears" == $DvtTimeAxisStyleUtils$$ ? $_nextDate$$.setFullYear($_nextDate$$.getFullYear() + 2) : $_nextDate$$.setYear($_nextDate$$.getYear() + 1);
    return $_nextDate$$;
  };
  $dvt$$18$$.$Obj$.$createSubclass$($DvtTimeAxisDefaults$$, $dvt$$18$$.$BaseComponentDefaults$, "DvtTimeAxisDefaults");
  $DvtTimeAxisDefaults$$.$VERSION_1$ = {backgroundColor:"rgba(255,255,255,0)", borderColor:"#d9dfe3", separatorColor:"#bcc7d2", labelStyle:new $dvt$$18$$.$CSSStyle$($dvt$$18$$.$BaseComponentDefaults$.$FONT_FAMILY_ALTA_12$ + "color: #333333;")};
  $dvt$$18$$.$Obj$.$createSubclass$($DvtTimeAxisFormatter$$, $dvt$$18$$.$Obj$);
  $DvtTimeAxisFormatter$$.$LONG$ = 0;
  $DvtTimeAxisFormatter$$.SHORT = 1;
  $DvtTimeAxisFormatter$$.prototype.Init = function $$DvtTimeAxisFormatter$$$$Init$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $locale$$7$$) {
    this.$_type$ = $dvt$$18$$;
    this.$_dateFormatStrings$ = $DvtTimeAxisStyleUtils$$;
    this.$_locale$ = $locale$$7$$;
    this.$_formats$ = [];
    this.$_formats$[0] = {};
    this.$_formats$[0].seconds = "HH:MM:ss";
    this.$_formats$[0].minutes = "HH:MM";
    this.$_formats$[0].hours = "HH:MM";
    this.$_formats$[0].days = "dddd";
    this.$_formats$[0].weeks = "m/dd";
    this.$_formats$[0].months = "mmmm";
    this.$_formats$[0].quarters = "mmmm";
    this.$_formats$[0].halfyears = "yyyy";
    this.$_formats$[0].years = "yyyy";
    this.$_formats$[0].twoyears = "yyyy";
    this.$_formats$[1] = {};
    this.$_formats$[1].seconds = "HH:MM:ss";
    this.$_formats$[1].minutes = "HH:MM";
    this.$_formats$[1].hours = "HH:MM";
    this.$_formats$[1].days = "m/dd";
    this.$_formats$[1].weeks = "m/dd";
    this.$_formats$[1].months = "mmm";
    this.$_formats$[1].quarters = "mmm";
    this.$_formats$[1].halfyears = "yy";
    this.$_formats$[1].years = "yy";
    this.$_formats$[1].twoyears = "yy";
  };
  $DvtTimeAxisFormatter$$.prototype.format = function $$DvtTimeAxisFormatter$$$$format$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $newString_timeZoneOffsets$$1$$) {
    $DvtTimeAxisStyleUtils$$ = this.$_formats$[this.$_type$][$DvtTimeAxisStyleUtils$$];
    if (null != $DvtTimeAxisStyleUtils$$) {
      var $dates$$1_isUTC$$ = !1;
      if ($newString_timeZoneOffsets$$1$$) {
        $dvt$$18$$ = $dvt$$18$$.getTime();
        for (var $dates$$1_isUTC$$ = Object.keys($newString_timeZoneOffsets$$1$$), $DvtTimeAxisCalendar$$ = 0, $DvtTimeAxisRenderer$$ = 0;$DvtTimeAxisRenderer$$ < $dates$$1_isUTC$$.length;$DvtTimeAxisRenderer$$++) {
          $dvt$$18$$ >= parseInt($dates$$1_isUTC$$[$DvtTimeAxisRenderer$$], 10) && ($DvtTimeAxisCalendar$$ = $newString_timeZoneOffsets$$1$$[$dates$$1_isUTC$$[$DvtTimeAxisRenderer$$]]);
        }
        $dvt$$18$$ = new Date($dvt$$18$$ + $DvtTimeAxisCalendar$$);
        $dates$$1_isUTC$$ = !0;
      }
      if (-1 != $DvtTimeAxisStyleUtils$$.indexOf(":")) {
        var $DvtTimeAxisFormatter$$ = ":"
      } else {
        -1 != $DvtTimeAxisStyleUtils$$.indexOf("/") && ($DvtTimeAxisFormatter$$ = "/");
      }
      if ($DvtTimeAxisFormatter$$) {
        $DvtTimeAxisStyleUtils$$ = $DvtTimeAxisStyleUtils$$.split($DvtTimeAxisFormatter$$);
        $newString_timeZoneOffsets$$1$$ = this.$getDateFormatValue$($dvt$$18$$, $DvtTimeAxisStyleUtils$$[0], $dates$$1_isUTC$$);
        for ($DvtTimeAxisRenderer$$ = 1;$DvtTimeAxisRenderer$$ < $DvtTimeAxisStyleUtils$$.length;$DvtTimeAxisRenderer$$++) {
          $newString_timeZoneOffsets$$1$$ += $DvtTimeAxisFormatter$$ + this.$getDateFormatValue$($dvt$$18$$, $DvtTimeAxisStyleUtils$$[$DvtTimeAxisRenderer$$], $dates$$1_isUTC$$);
        }
        return $newString_timeZoneOffsets$$1$$;
      }
      return this.$getDateFormatValue$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $dates$$1_isUTC$$);
    }
    try {
      return $dvt$$18$$.toLocaleString(this.$_locale$);
    } catch ($e$$10$$) {
    }
    return $dvt$$18$$.toLocaleString();
  };
  $DvtTimeAxisFormatter$$.prototype.$getDateFormatValue$ = function $$DvtTimeAxisFormatter$$$$$getDateFormatValue$$($dvt$$18$$, $DvtTimeAxisStyleUtils$$, $isUTC$$1$$) {
    if ($isUTC$$1$$) {
      switch($DvtTimeAxisStyleUtils$$) {
        case "ss":
          return $dvt$$18$$ = $dvt$$18$$.getUTCSeconds(), 10 > $dvt$$18$$ ? "0" + $dvt$$18$$ : $dvt$$18$$;
        case "HH":
          return $dvt$$18$$ = $dvt$$18$$.getUTCHours(), 10 > $dvt$$18$$ ? "0" + $dvt$$18$$ : $dvt$$18$$;
        case "MM":
          return $dvt$$18$$ = $dvt$$18$$.getUTCMinutes(), 10 > $dvt$$18$$ ? "0" + $dvt$$18$$ : $dvt$$18$$;
        case "dd":
          return $dvt$$18$$ = $dvt$$18$$.getUTCDate(), 10 > $dvt$$18$$ ? "0" + $dvt$$18$$ : $dvt$$18$$;
        case "dddd":
          return this.$_dateFormatStrings$.$dayNames$[$dvt$$18$$.getUTCDay() + 7];
        case "m":
          return $dvt$$18$$.getUTCMonth() + 1;
        case "mmm":
          return this.$_dateFormatStrings$.$monthNames$[$dvt$$18$$.getUTCMonth()];
        case "mmmm":
          return this.$_dateFormatStrings$.$monthNames$[$dvt$$18$$.getUTCMonth() + 12];
        case "yy":
          return $dvt$$18$$.getUTCFullYear().toString().substring(2, 4);
        default:
          return $dvt$$18$$.getUTCFullYear();
      }
    } else {
      switch($DvtTimeAxisStyleUtils$$) {
        case "ss":
          return $dvt$$18$$ = $dvt$$18$$.getSeconds(), 10 > $dvt$$18$$ ? "0" + $dvt$$18$$ : $dvt$$18$$;
        case "HH":
          return $dvt$$18$$ = $dvt$$18$$.getHours(), 10 > $dvt$$18$$ ? "0" + $dvt$$18$$ : $dvt$$18$$;
        case "MM":
          return $dvt$$18$$ = $dvt$$18$$.getMinutes(), 10 > $dvt$$18$$ ? "0" + $dvt$$18$$ : $dvt$$18$$;
        case "dd":
          return $dvt$$18$$ = $dvt$$18$$.getDate(), 10 > $dvt$$18$$ ? "0" + $dvt$$18$$ : $dvt$$18$$;
        case "dddd":
          return this.$_dateFormatStrings$.$dayNames$[$dvt$$18$$.getDay() + 7];
        case "m":
          return $dvt$$18$$.getMonth() + 1;
        case "mmm":
          return this.$_dateFormatStrings$.$monthNames$[$dvt$$18$$.getMonth()];
        case "mmmm":
          return this.$_dateFormatStrings$.$monthNames$[$dvt$$18$$.getMonth() + 12];
        case "yy":
          return $dvt$$18$$.getFullYear().toString().substring(2, 4);
        default:
          return $dvt$$18$$.getFullYear();
      }
    }
  };
  $dvt$$18$$.$Obj$.$createSubclass$($DvtTimeAxisParser$$, $dvt$$18$$.$Obj$, "DvtTimeAxisParser");
  $DvtTimeAxisParser$$.prototype.parse = function $$DvtTimeAxisParser$$$$parse$($dvt$$18$$) {
    this.$_startTime$ = new Date($dvt$$18$$.start);
    this.$_endTime$ = new Date($dvt$$18$$.end);
    var $DvtTimeAxisStyleUtils$$ = this.$ParseRootAttributes$();
    $DvtTimeAxisStyleUtils$$.$inlineStyle$ = $dvt$$18$$.style;
    $DvtTimeAxisStyleUtils$$.id = $dvt$$18$$.id;
    $DvtTimeAxisStyleUtils$$.$shortDesc$ = $dvt$$18$$.shortDesc;
    $DvtTimeAxisStyleUtils$$.$timeZoneOffsets$ = $dvt$$18$$._tzo;
    $DvtTimeAxisStyleUtils$$.$itemPosition$ = $dvt$$18$$._ip;
    $DvtTimeAxisStyleUtils$$.$customTimeScales$ = $dvt$$18$$._cts;
    $DvtTimeAxisStyleUtils$$.$customFormatScales$ = $dvt$$18$$._cfs;
    $DvtTimeAxisStyleUtils$$.scale = $dvt$$18$$.scale;
    $DvtTimeAxisStyleUtils$$.$converter$ = $dvt$$18$$.converter;
    $DvtTimeAxisStyleUtils$$.$zoomOrder$ = $dvt$$18$$.zoomOrder ? $dvt$$18$$.zoomOrder : null;
    $DvtTimeAxisStyleUtils$$.orientation = $dvt$$18$$.orientation ? $dvt$$18$$.orientation : "horizontal";
    return $DvtTimeAxisStyleUtils$$;
  };
  $DvtTimeAxisParser$$.prototype.$ParseRootAttributes$ = function $$DvtTimeAxisParser$$$$$ParseRootAttributes$$() {
    var $dvt$$18$$ = {};
    $dvt$$18$$.start = this.$_startTime$.getTime();
    $dvt$$18$$.end = this.$_endTime$.getTime();
    return $dvt$$18$$;
  };
  var $DvtTimeAxisRenderer$$ = {};
  $dvt$$18$$.$Obj$.$createSubclass$($DvtTimeAxisRenderer$$, $dvt$$18$$.$Obj$, "DvtTimeAxisRenderer");
  $DvtTimeAxisRenderer$$.$renderTimeAxis$ = function $$DvtTimeAxisRenderer$$$$renderTimeAxis$$($dvt$$18$$) {
    if ($dvt$$18$$.$hasValidOptions$()) {
      var $DvtTimeAxisCalendar$$ = $dvt$$18$$.$getSize$();
      $DvtTimeAxisRenderer$$.$_renderAxisBlock$($dvt$$18$$, $DvtTimeAxisCalendar$$, $DvtTimeAxisStyleUtils$$.$getAxisSeparatorStyle$($dvt$$18$$.$Options$));
    }
  };
  $DvtTimeAxisRenderer$$.$_renderAxisBlock$ = function $$DvtTimeAxisRenderer$$$$_renderAxisBlock$$($timeAxis$$4$$, $DvtTimeAxisCalendar$$, $separatorStyle$$) {
    var $axisStart$$4$$ = 0, $DvtTimeAxisFormatter$$ = $timeAxis$$4$$.$getCtx$();
    if (null == $timeAxis$$4$$.$_axis$) {
      var $cp$$12$$ = new $dvt$$18$$.$ClipPath$;
      $timeAxis$$4$$.$isVertical$() ? ($timeAxis$$4$$.$_axis$ = new $dvt$$18$$.Rect($DvtTimeAxisFormatter$$, $axisStart$$4$$, -$timeAxis$$4$$.$getBorderWidth$("top"), $DvtTimeAxisCalendar$$, $timeAxis$$4$$.$_axisLength$, "axis"), $cp$$12$$.$addRect$($axisStart$$4$$, 0, $DvtTimeAxisCalendar$$, $timeAxis$$4$$.$_contentLength$)) : ($timeAxis$$4$$.$_axis$ = new $dvt$$18$$.Rect($DvtTimeAxisFormatter$$, -$timeAxis$$4$$.$getBorderWidth$("left"), $axisStart$$4$$, $timeAxis$$4$$.$_axisLength$, $DvtTimeAxisCalendar$$, 
      "axis"), $cp$$12$$.$addRect$(0, $axisStart$$4$$, $timeAxis$$4$$.$_contentLength$, $DvtTimeAxisCalendar$$));
      $timeAxis$$4$$.$_axis$.$setCSSStyle$($timeAxis$$4$$.$_axisStyle$);
      $timeAxis$$4$$.$_axis$.$setPixelHinting$();
      $timeAxis$$4$$.$_axis$.$setClipPath$($cp$$12$$);
      $timeAxis$$4$$.$addChild$($timeAxis$$4$$.$_axis$);
      ($DvtTimeAxisCalendar$$ = $DvtTimeAxisStyleUtils$$.$getAxisClass$($timeAxis$$4$$.$Options$)) && $timeAxis$$4$$.$_axis$.$getImpl$().$getElem$().setAttribute("class", $DvtTimeAxisCalendar$$);
    } else {
      $timeAxis$$4$$.$_axis$.$setClipPath$(null), $cp$$12$$ = new $dvt$$18$$.$ClipPath$, $timeAxis$$4$$.$isVertical$() ? ($timeAxis$$4$$.$_axis$.$setX$($axisStart$$4$$), $timeAxis$$4$$.$_axis$.$setY$(-$timeAxis$$4$$.$getBorderWidth$("top")), $timeAxis$$4$$.$_axis$.$setWidth$($DvtTimeAxisCalendar$$), $timeAxis$$4$$.$_axis$.$setHeight$($timeAxis$$4$$.$_axisLength$), $cp$$12$$.$addRect$($axisStart$$4$$, 0, $DvtTimeAxisCalendar$$, $timeAxis$$4$$.$_contentLength$)) : ($timeAxis$$4$$.$_axis$.$setX$(-$timeAxis$$4$$.$getBorderWidth$("left")), 
      $timeAxis$$4$$.$_axis$.$setY$($axisStart$$4$$), $timeAxis$$4$$.$_axis$.$setWidth$($timeAxis$$4$$.$_axisLength$), $timeAxis$$4$$.$_axis$.$setHeight$($DvtTimeAxisCalendar$$), $cp$$12$$.$addRect$(0, $axisStart$$4$$, $timeAxis$$4$$.$_contentLength$, $DvtTimeAxisCalendar$$)), $timeAxis$$4$$.$_axis$.$setClipPath$($cp$$12$$);
    }
    $timeAxis$$4$$.$_axis$.$removeChildren$();
    $timeAxis$$4$$.$_axis$.$getImpl$().$getElem$().setAttribute("stroke-dasharray", $timeAxis$$4$$.$calcStrokeDashArray$());
    $separatorStyle$$ = new $dvt$$18$$.$CSSStyle$($separatorStyle$$);
    $timeAxis$$4$$.$_separatorStroke$ = new $dvt$$18$$.$SolidStroke$($separatorStyle$$.$getStyle$($dvt$$18$$.$CSSStyle$.$COLOR$));
    $DvtTimeAxisCalendar$$ = $timeAxis$$4$$.$_contentSize$;
    $axisStart$$4$$ = $axisStart$$4$$ + $timeAxis$$4$$.$isVertical$() ? $timeAxis$$4$$.$getBorderWidth$("left") : $timeAxis$$4$$.$getBorderWidth$("top");
    $DvtTimeAxisRenderer$$.$_renderAxisTicksLabels$($timeAxis$$4$$, $timeAxis$$4$$.$_canvasSize$, $timeAxis$$4$$.$_axis$, $timeAxis$$4$$.$_contentLength$, $axisStart$$4$$ + $DvtTimeAxisCalendar$$, $axisStart$$4$$, $axisStart$$4$$);
  };
  $DvtTimeAxisRenderer$$.$_renderAxisTicksLabels$ = function $$DvtTimeAxisRenderer$$$$_renderAxisTicksLabels$$($timeAxis$$5$$, $DvtTimeAxisCalendar$$, $container$$195_separatorClass$$, $length$$24$$, $DvtTimeAxisFormatter$$, $tickStart$$, $DvtTimeAxisDefaults$$) {
    var $context$$424$$ = $timeAxis$$5$$.$getCtx$(), $isRTL$$57$$ = $dvt$$18$$.$Agent$.$isRightToLeft$($context$$424$$), $block$$ = new $dvt$$18$$.$Container$($context$$424$$, "block_0_" + $DvtTimeAxisCalendar$$);
    $block$$.$startPos$ = 0;
    $block$$.$endPos$ = $DvtTimeAxisCalendar$$;
    $container$$195_separatorClass$$.$addChild$($block$$);
    $DvtTimeAxisCalendar$$ = $DvtTimeAxisStyleUtils$$.$getAxisLabelClass$($timeAxis$$5$$.$Options$);
    $container$$195_separatorClass$$ = $DvtTimeAxisStyleUtils$$.$getAxisSeparatorClass$($timeAxis$$5$$.$Options$);
    for (var $dates$$2$$ = $timeAxis$$5$$.$_dates$[$timeAxis$$5$$.$_zoomLevelOrder$], $labels$$32$$ = $timeAxis$$5$$.$_labels$[$timeAxis$$5$$.$_zoomLevelOrder$], $i$$669$$ = 0;$i$$669$$ < $dates$$2$$.length - 1;$i$$669$$++) {
      var $date$$18$$ = $dates$$2$$[$i$$669$$], $next$$17_nextPos$$ = $dates$$2$$[$i$$669$$ + 1], $currentPos$$ = $dvt$$18$$.$TimeAxis$.$getDatePosition$($timeAxis$$5$$.$_start$, $timeAxis$$5$$.$_end$, $date$$18$$, $length$$24$$), $next$$17_nextPos$$ = $dvt$$18$$.$TimeAxis$.$getDatePosition$($timeAxis$$5$$.$_start$, $timeAxis$$5$$.$_end$, $next$$17_nextPos$$, $length$$24$$), $maxLength$$ = $next$$17_nextPos$$ - $currentPos$$;
      0 != $currentPos$$ && (($timeAxis$$5$$.$isVertical$() ? $DvtTimeAxisRenderer$$.$_addTick$($context$$424$$, $block$$, $DvtTimeAxisFormatter$$, $tickStart$$, $currentPos$$, $currentPos$$, $timeAxis$$5$$.$_separatorStroke$, "s_tick" + $date$$18$$, $container$$195_separatorClass$$) : $isRTL$$57$$ ? $DvtTimeAxisRenderer$$.$_addTick$($context$$424$$, $block$$, $length$$24$$ - $currentPos$$, $length$$24$$ - $currentPos$$, $DvtTimeAxisFormatter$$, $tickStart$$, $timeAxis$$5$$.$_separatorStroke$, "s_tick" + 
      $date$$18$$, $container$$195_separatorClass$$) : $DvtTimeAxisRenderer$$.$_addTick$($context$$424$$, $block$$, $currentPos$$, $currentPos$$, $DvtTimeAxisFormatter$$, $tickStart$$, $timeAxis$$5$$.$_separatorStroke$, "s_tick" + $date$$18$$, $container$$195_separatorClass$$)).time = $date$$18$$);
      $timeAxis$$5$$.$isVertical$() ? $DvtTimeAxisRenderer$$.$_addAxisLabel$($block$$, $labels$$32$$[$i$$669$$], $DvtTimeAxisDefaults$$ + ($DvtTimeAxisFormatter$$ - $DvtTimeAxisDefaults$$) / 2, $currentPos$$ + ($next$$17_nextPos$$ - $currentPos$$) / 2, $DvtTimeAxisFormatter$$ - $DvtTimeAxisDefaults$$, $DvtTimeAxisCalendar$$) : $isRTL$$57$$ ? $DvtTimeAxisRenderer$$.$_addAxisLabel$($block$$, $labels$$32$$[$i$$669$$], $length$$24$$ - ($currentPos$$ + ($next$$17_nextPos$$ - $currentPos$$) / 2), $DvtTimeAxisDefaults$$ + 
      ($DvtTimeAxisFormatter$$ - $DvtTimeAxisDefaults$$) / 2, $maxLength$$, $DvtTimeAxisCalendar$$) : $DvtTimeAxisRenderer$$.$_addAxisLabel$($block$$, $labels$$32$$[$i$$669$$], $currentPos$$ + ($next$$17_nextPos$$ - $currentPos$$) / 2, $DvtTimeAxisDefaults$$ + ($DvtTimeAxisFormatter$$ - $DvtTimeAxisDefaults$$) / 2, $maxLength$$, $DvtTimeAxisCalendar$$);
    }
  };
  $DvtTimeAxisRenderer$$.$_addAxisLabel$ = function $$DvtTimeAxisRenderer$$$$_addAxisLabel$$($container$$196$$, $DvtTimeAxisStyleUtils$$, $x$$230$$, $y$$203$$, $DvtTimeAxisCalendar$$, $DvtTimeAxisRenderer$$) {
    $DvtTimeAxisStyleUtils$$.$setX$($x$$230$$);
    $DvtTimeAxisStyleUtils$$.$setY$($y$$203$$);
    $DvtTimeAxisStyleUtils$$.$isTruncated$() && $DvtTimeAxisStyleUtils$$.$setTextString$($DvtTimeAxisStyleUtils$$.$getUntruncatedTextString$());
    $dvt$$18$$.$TextUtils$.$fitText$($DvtTimeAxisStyleUtils$$, $DvtTimeAxisCalendar$$, Infinity, $container$$196$$);
    $DvtTimeAxisStyleUtils$$.$alignCenter$();
    $dvt$$18$$.$TextUtils$.$centerTextVertically$($DvtTimeAxisStyleUtils$$, $y$$203$$);
    $DvtTimeAxisRenderer$$ && $DvtTimeAxisStyleUtils$$.$getImpl$().$getElem$().setAttribute("class", $DvtTimeAxisRenderer$$);
  };
  $DvtTimeAxisRenderer$$.$_addTick$ = function $$DvtTimeAxisRenderer$$$$_addTick$$($context$$425_line$$23$$, $DvtTimeAxisStyleUtils$$, $x1$$45$$, $x2$$43$$, $DvtTimeAxisCalendar$$, $DvtTimeAxisRenderer$$, $DvtTimeAxisFormatter$$, $id$$221$$, $tickClass$$) {
    $context$$425_line$$23$$ = new $dvt$$18$$.$Line$($context$$425_line$$23$$, $x1$$45$$, $DvtTimeAxisCalendar$$, $x2$$43$$, $DvtTimeAxisRenderer$$, $id$$221$$);
    $context$$425_line$$23$$.$setStroke$($DvtTimeAxisFormatter$$);
    $context$$425_line$$23$$.$setPixelHinting$();
    $DvtTimeAxisStyleUtils$$.$addChild$($context$$425_line$$23$$);
    $tickClass$$ && $context$$425_line$$23$$.$getImpl$().$getElem$().setAttribute("class", $tickClass$$);
    return $context$$425_line$$23$$;
  };
  var $DvtTimeAxisStyleUtils$$ = {};
  $dvt$$18$$.$Obj$.$createSubclass$($DvtTimeAxisStyleUtils$$, $dvt$$18$$.$Obj$, "DvtTimeAxisStyleUtils");
  $DvtTimeAxisStyleUtils$$.$DEFAULT_BORDER_WIDTH$ = 1;
  $DvtTimeAxisStyleUtils$$.$DEFAULT_SEPARATOR_WIDTH$ = 1;
  $DvtTimeAxisStyleUtils$$.$DEFAULT_INTERVAL_WIDTH$ = 50;
  $DvtTimeAxisStyleUtils$$.$DEFAULT_INTERVAL_HEIGHT$ = 21;
  $DvtTimeAxisStyleUtils$$.$DEFAULT_INTERVAL_PADDING$ = 2;
  $DvtTimeAxisStyleUtils$$.$getAxisStyle$ = function $$DvtTimeAxisStyleUtils$$$$getAxisStyle$$($dvt$$18$$) {
    var $DvtTimeAxisCalendar$$ = "", $style$$117$$ = $DvtTimeAxisStyleUtils$$.$getBackgroudColor$($dvt$$18$$);
    $style$$117$$ && ($DvtTimeAxisCalendar$$ = $DvtTimeAxisCalendar$$ + "background-color:" + $style$$117$$ + ";");
    ($style$$117$$ = $DvtTimeAxisStyleUtils$$.$getBorderColor$($dvt$$18$$)) && ($DvtTimeAxisCalendar$$ = $DvtTimeAxisCalendar$$ + "border-color:" + $style$$117$$ + ";");
    ($style$$117$$ = $DvtTimeAxisStyleUtils$$.$getBorderWidth$()) && ($DvtTimeAxisCalendar$$ = $DvtTimeAxisCalendar$$ + "border-width:" + $style$$117$$ + ";");
    return $DvtTimeAxisCalendar$$;
  };
  $DvtTimeAxisStyleUtils$$.$getBackgroudColor$ = function $$DvtTimeAxisStyleUtils$$$$getBackgroudColor$$($dvt$$18$$) {
    return $dvt$$18$$.backgroundColor;
  };
  $DvtTimeAxisStyleUtils$$.$getBorderColor$ = function $$DvtTimeAxisStyleUtils$$$$getBorderColor$$($dvt$$18$$) {
    return $dvt$$18$$.borderColor;
  };
  $DvtTimeAxisStyleUtils$$.$getBorderWidth$ = function $$DvtTimeAxisStyleUtils$$$$getBorderWidth$$() {
    return $DvtTimeAxisStyleUtils$$.$DEFAULT_BORDER_WIDTH$;
  };
  $DvtTimeAxisStyleUtils$$.$getAxisLabelStyle$ = function $$DvtTimeAxisStyleUtils$$$$getAxisLabelStyle$$($dvt$$18$$) {
    return $dvt$$18$$.labelStyle;
  };
  $DvtTimeAxisStyleUtils$$.$getSeparatorColor$ = function $$DvtTimeAxisStyleUtils$$$$getSeparatorColor$$($dvt$$18$$) {
    return $dvt$$18$$.separatorColor;
  };
  $DvtTimeAxisStyleUtils$$.$getAxisSeparatorStyle$ = function $$DvtTimeAxisStyleUtils$$$$getAxisSeparatorStyle$$($dvt$$18$$) {
    var $DvtTimeAxisCalendar$$ = "";
    ($dvt$$18$$ = $DvtTimeAxisStyleUtils$$.$getSeparatorColor$($dvt$$18$$)) && ($DvtTimeAxisCalendar$$ = $DvtTimeAxisCalendar$$ + "color:" + $dvt$$18$$ + ";");
    return $DvtTimeAxisCalendar$$;
  };
  $DvtTimeAxisStyleUtils$$.$getAxisClass$ = function $$DvtTimeAxisStyleUtils$$$$getAxisClass$$($dvt$$18$$) {
    return $dvt$$18$$._resources ? $dvt$$18$$._resources.axisClass : void 0;
  };
  $DvtTimeAxisStyleUtils$$.$getAxisBorderClass$ = function $$DvtTimeAxisStyleUtils$$$$getAxisBorderClass$$($dvt$$18$$) {
    return $dvt$$18$$._resources ? $dvt$$18$$._resources.axisBorderClass : void 0;
  };
  $DvtTimeAxisStyleUtils$$.$getAxisLabelClass$ = function $$DvtTimeAxisStyleUtils$$$$getAxisLabelClass$$($dvt$$18$$) {
    return $dvt$$18$$._resources ? $dvt$$18$$._resources.axisLabelClass : void 0;
  };
  $DvtTimeAxisStyleUtils$$.$getAxisSeparatorClass$ = function $$DvtTimeAxisStyleUtils$$$$getAxisSeparatorClass$$($dvt$$18$$) {
    return $dvt$$18$$._resources ? $dvt$$18$$._resources.axisSeparatorClass : void 0;
  };
  $DvtTimeAxisStyleUtils$$.$isBorderTopVisible$ = function $$DvtTimeAxisStyleUtils$$$$isBorderTopVisible$$($dvt$$18$$) {
    return $dvt$$18$$._resources ? $dvt$$18$$._resources.borderTopVisible : !1;
  };
  $DvtTimeAxisStyleUtils$$.$isBorderRightVisible$ = function $$DvtTimeAxisStyleUtils$$$$isBorderRightVisible$$($dvt$$18$$) {
    return $dvt$$18$$._resources ? $dvt$$18$$._resources.borderRightVisible : !1;
  };
  $DvtTimeAxisStyleUtils$$.$isBorderBottomVisible$ = function $$DvtTimeAxisStyleUtils$$$$isBorderBottomVisible$$($dvt$$18$$) {
    return $dvt$$18$$._resources ? $dvt$$18$$._resources.borderBottomVisible : !1;
  };
  $DvtTimeAxisStyleUtils$$.$isBorderLeftVisible$ = function $$DvtTimeAxisStyleUtils$$$$isBorderLeftVisible$$($dvt$$18$$) {
    return $dvt$$18$$._resources ? $dvt$$18$$._resources.borderLeftVisible : !1;
  };
  $dvt$$18$$.$exportProperty$($dvt$$18$$, "TimeAxis", $dvt$$18$$.$TimeAxis$);
  $dvt$$18$$.$exportProperty$($dvt$$18$$.$TimeAxis$, "newInstance", $dvt$$18$$.$TimeAxis$.newInstance);
  $dvt$$18$$.$exportProperty$($dvt$$18$$.$TimeAxis$.prototype, "render", $dvt$$18$$.$TimeAxis$.prototype.$render$);
})(dvt);
